﻿using System;
using System.Collections;
using System.IO;
using System.Net;
using System.Text;

namespace DIgen
{
	class Program
	{
		static void Main(string[] args)
		{
			int serverCount;
			if (args.Length == 0)
			{
				Console.WriteLine("Usage : DIgen.exe X");
				Console.WriteLine("Where X is the number of pub servers to enumerate.");
				return;
			}
			try
			{
				serverCount = Convert.ToByte(args[0]);
			}
			catch 
			{
				Console.WriteLine("Usage : DIgen.exe X");
				Console.WriteLine("Where X is the number of pub servers to enumerate.");
				return;
			}
			Console.WriteLine("Create Request");

			// prepare the web page we will be asking for
			HttpWebRequest request = (HttpWebRequest)
				WebRequest.Create("http://www.di.fm");

			Console.WriteLine("Execute Request");
			// execute the request
			HttpWebResponse response = (HttpWebResponse)
				request.GetResponse();

			Console.WriteLine("Read Response");
			// we will read data via the response stream
			Stream resStream = response.GetResponseStream();
			if (resStream == null)
			{
				Console.WriteLine("Read Response Failed!");
				return;
			}

			StreamReader reader = new StreamReader(resStream, Encoding.UTF8);

			string resStr = reader.ReadToEnd();
			ArrayList arl = new ArrayList();
			Console.WriteLine("Parse Response");
			// print out page source
			resStr = resStr.Substring(resStr.IndexOf("<a href=\"#\">Channels</a>")+32);
			while (true)
			{
				resStr = resStr.Substring(resStr.IndexOf("<a href=\"/") + 10);
				string outStr = resStr.Substring(0,resStr.IndexOf("\">"));
				if (outStr == "calendar")
				{
					break;
				}
				resStr = resStr.Substring(resStr.IndexOf("<span>") + 6);
				arl.Add(outStr + "|" +resStr.Substring(0, resStr.IndexOf("</span>")));

			}

			Console.WriteLine("Write File");
			StreamWriter file = new StreamWriter("di.pls");

			file.WriteLine("[playlist]");
			file.WriteLine("NumberOfEntries=" + arl.Count * 7);

			int entryCount = 0;
			foreach (string st in arl)
			{
				for (int i = 1; i <= serverCount; i++)
				{
					entryCount++;
					file.WriteLine("File" + entryCount + "=http://pub" + i + ".di.fm:80/di_" + st.Split('|')[0] + "_aacplus");
					file.WriteLine("Title" + entryCount + "=" + st.Split('|')[1] + " - Digitally Imported");
					file.WriteLine("Lenght" + entryCount + "=-1");
				}
				Console.WriteLine("Added : " + st);

			}
			file.WriteLine("Version=2");
			file.Flush();
			file.Close();
			Console.WriteLine("Done.");

		}
	}

}
